import {ICourse} from "./types"
import {acquireCourse, exitCourse, findJsonCourse, getTimeNow, logAndNotifyUser, sleep} from "./includes"
import {JsonCourseList} from "./poll"

export async function monitProcess(course: ICourse) {
    let lastSyrs = -1
    while (true) {
        let single = findJsonCourse(course)
        if (single == undefined) {
            console.log('[monit]无法找到课程 ' + course.kch + ' on channel ' + course.channel)
        } else {
            if (lastSyrs == -1) {
                console.log('[monit]开始监控 ' + single.kcmc + ' ，当前剩余人数：' + single.syrs)
                lastSyrs = parseInt(single.syrs)
            } else {
                if (lastSyrs != parseInt(single.syrs)) {
                    logAndNotifyUser('[monit]' + single.kcmc + ' 新剩余人数：' + single.syrs + ' at ' + getTimeNow())
                    lastSyrs = parseInt(single.syrs)
                }
            }
        }
        await sleep(50)
    }
}

export async function acquireProcess(course: ICourse) {
    while (true) {
        let single = findJsonCourse(course)
        if (single == undefined) {
            console.log('[acquire]无法找到课程 ' + course.kch + ' on channel ' + course.channel)
        } else {
            if (parseInt(single.syrs) > 0) {
                logAndNotifyUser('[acquire]发现 ' + single.kcmc + ' 剩余人数为' + single.syrs + '，进行抢课 at ' + getTimeNow())
                if (await acquireCourse(single, course.channel)) {
                    logAndNotifyUser('[acquire]抢课成功 ' + single.kcmc + ' at ' + getTimeNow())
                    return
                } else {
                    logAndNotifyUser('[acquire]抢课失败 ' + single.kcmc + ' at ' + getTimeNow())
                }
            }
        }
        await sleep(50)
    }
}

export async function replaceProcess(courseList: ICourse[], exit: ICourse) {
    while (true) {
        let exitJsonCourse = findJsonCourse(exit)
        if (exitJsonCourse == undefined) {
            console.log('[replace]找不到需要需要退课的课程 ' + exit.kch + ' on channel ' + exit.channel)
        } else {
            for (let course of courseList) {
                let single = findJsonCourse(course)
                if (single == undefined) {
                    console.log('[replace]无法找到课程 ' + course.kch + ' on channel ' + course.channel)
                    continue
                }
                if (parseInt(single.syrs) > 0) {
                    logAndNotifyUser('[replace]发现 ' + single.kcmc + ' 剩余人数为' + single.syrs + '，进行换课 at ' + getTimeNow())
                    if (!(await exitCourse(exitJsonCourse))) {
                        logAndNotifyUser('[replace]退课 ' + exitJsonCourse.kcmc + ' 失败 at ' + getTimeNow())
                    }
                    if (await acquireCourse(single, course.channel)) {
                        logAndNotifyUser('[replace]换课 ' + single.kcmc + ' 成功 at ' + getTimeNow())
                        return
                    } else {
                        logAndNotifyUser('[replace]选课 ' + single.kcmc + ' 失败，进行回滚 at ' + getTimeNow())
                        if (await acquireCourse(exitJsonCourse, exit.channel)) {
                            logAndNotifyUser('[replace]回滚 ' + single.kcmc + ' 成功 at ' + getTimeNow())
                        } else {
                            logAndNotifyUser('[replace]回滚 ' + single.kcmc + ' 失败 at ' + getTimeNow())
                        }
                    }
                }
            }
        }
        await sleep(50)
    }
}
