export type TChannel = 'bx' | 'xx' | 'rx'

export interface ICourse {
    kch: string,
    kxh: number,
    channel: TChannel
}

export interface IAppConfig {
    cookie: string,
    qmsgKey: string,
    tgApiDomain: string,
    tgApiKey: string,
    tgChatId: number,
    interval: number,
    channels: TChannel[],
    monit?: {
        list: ICourse[]
    },
    acquire?: {
        list: ICourse[]
    },
    replace?: {
        list: ICourse[],
        exit: ICourse
    }
}

export interface IJsonCourse {
    parentjx0404id: null;
    mfkc: string;
    ksfs: string;
    jx02kcmkid: null;
    ktmc: string;
    tzdlb: string;
    kcsx: string;
    skfs: string;
    kch: string;
    syrs: string;
    kxh: string;
    sksj: string;
    szkcfl: string;
    kcjj: null;
    skfsmc: string;
    wlpt: null;
    kcxzmc: string;
    kexuhao: null;
    xbyq: null;
    sftk: null;
    kkdw: string;
    kcxzm: string;
    szkcflmc: string;
    xnxq01id: string;
    dwmc: string;
    kxhnew: string;
    pkrs: number;
    xkrs: number;
    fzmc: null;
    cfbs: null;
    kcmc: string;
    xyxsnj: null;
    kkapList: KkapList[];
    dyrsbl: null;
    isnetworkcourse: string;
    sklsid: string;
    skls: string;
    xqid: string;
    sfkfxk: string;
    skdd: string;
    xf: number;
    skdws: null;
    txsfkxq: string;
    xmmc: null;
    zxs: number;
    jx0404id: string;
    xqmc: string;
    jx02id: string;
    xbyqmc: null;
    jkfs: null;
}

export interface KkapList {
    jssj: string;
    jzwmc: string;
    jgxm: string;
    skjcmc: string;
    skzcList: string[];
    xq: string;
    kbjcmsid: string;
    kkzc: string;
    kssj: string;
    jsmc: string;
    kkdlb: string;
}
